#ifndef SI_INTERFACE
#define SI_INTERFACE

#include "SIformula.h"
#include "SIsimplifier.h"

#define ESTACKSIZE  20

//Possible states
enum SIInterfaceState{UNINITIALIZED,
		       NOFORMULAPRESENT,
		       BUILDINGAFORMULA,
		       FORMULAISPRESENT};

class SIInterface {

 private:
 protected:
  SIsimplifier *SISimp;
  SIInterfaceState state;
  SIformula * eStackForm[ESTACKSIZE];
  SIarithmetic * eStackArit[ESTACKSIZE];
  int formTop;
  int aritTop;
  SIformula * currentAssumptions;
  SIformula * currentFormula;
  char replyCode[256];
  
 public:
  SIInterface(void);
  const char * init();
  const char * reset();
  const char * formulaStart();
  const char * formulaInteger(char *data);
  const char * formulaReal(char *data);
  const char * formulaBoolean(char *data);
  const char * formulaSymbol(char *data);
  const char * formulaOperator(char *data);
  const char * formulaFinalize();
  const char * prove(bool proofGoal);
  const char * append(bool logicAssumption);
  const char * discard();
  const char * clear();
  ~SIInterface();
};

#endif
