#ifndef SICSTUS_C_INTERFACE_TWO
#define SICSTUS_C_INTERFACE_TWO

/* This file contains the interface to pass query strings and receive back 
   answers from the prolog interpreter */


#include <fstream>
#include "myvector.h"

class SicstusC {

 protected:
  std::ifstream fin;
  std::ofstream fout;
  unsigned int initialized;

 public:

  // Void constructor
  SicstusC(void);

  // Initializes the prolog engine searching for the communication pipes
  // return 0 if the initilization fails, 1 if it is successful
  // slot must be 0 or 1, at most two prolog processes are allowed
  unsigned int initialize(unsigned int slot);

  void closeProlog(void);

  // returns in a myvector object all the lines that are the answer to the
  // query string q
  myvector<char*> query(char* q);

};

#endif
