#ifndef SI_UTILS
#define SI_UTILS

#include <string>

/* Warning: using doubles greater than 1,000,000,000,000,000 can cause
   impredictable behaviours in double string representation if more
   than 16 digits are used in float initialization  */

// Converts a C++ string to a C/C++ char*
char* stringToChar(std::string toconvert);

// Converts a C++ string to an integer, if the string represents a number
long stringToLong(std::string toconvert);

// Converts an integer to a C/C++ char*
char* int_longToChar(long toconvert);

// Truncates a double (e.g. truncate(15.6783)=15.0000 )
double truncate(double totrunc);

// Converts a double to a C/C++ char*
char* floatToChar(double toconvert);

// returns the integer part (characteristic) of in as a char*
char* fchr(double in);

// returns the mantissa of in as a char*
char* mantissa(double in);

// Converts a string to a double, if the string represents a double
double stringToDouble(std::string toconvert);

#endif
