#include <string>
#include <stdlib.h>
#include <math.h>
#include <iostream>


/* Warning: using doubles greater than 1,000,000,000,000,000 can cause
   impredictable behaviours in double string representation if more
   than 16 digits are used in float initialization  */



/************************ AUXILIARY FUNCTIONS *******************************/


// itoa converts a C/C++ char* to an integer, if possible

void itoa(long toconvert_in, char *converted) {
  int count=0;
  int digits=1;

  long toconvert = toconvert_in; //necessary for managing the case toconvert_in == int'min
  if(toconvert<0) { 
    converted[count++]='-'; 
    toconvert=-toconvert; 
  }

  for(long i=toconvert;i>=10L;i=i/10L) digits++;

  if (toconvert==0) { 
    converted[count++]='0'; 
    converted[count]='\0';
    return; 
  }
  
  for (long i = (long)pow(10,digits-1); i>1L; i/=10L){
    switch(toconvert/i) {
    case 0: converted[count++]='0';
      break;
    case 1: converted[count++]='1';
      break;
    case 2: converted[count++]='2';
      break;
    case 3: converted[count++]='3';
      break;
    case 4: converted[count++]='4';
      break;
    case 5: converted[count++]='5';
      break;
    case 6: converted[count++]='6';
      break;
    case 7: converted[count++]='7';
      break;
    case 8: converted[count++]='8';
      break;
    case 9: converted[count++]='9';
      break;
    }
    toconvert%=i;
  }

  switch(toconvert) {
  case 0: converted[count++]='0';
    break;
  case 1: converted[count++]='1';
    break;
  case 2: converted[count++]='2';
    break;
  case 3: converted[count++]='3';
    break;
  case 4: converted[count++]='4';
    break;
  case 5: converted[count++]='5';
    break;
  case 6: converted[count++]='6';
    break;
  case 7: converted[count++]='7';
    break;
  case 8: converted[count++]='8';
    break;
  case 9: converted[count++]='9';
    break;
  }
  converted[count]='\0';
}

// Converts a char into a double

double charToDouble(char p)
{
  switch(p)
    {
    case '0': return 0.0;
    case '1': return 1.0;
    case '2': return 2.0;
    case '3': return 3.0;
    case '4': return 4.0;
    case '5': return 5.0;
    case '6': return 6.0;
    case '7': return 7.0;
    case '8': return 8.0;
    case '9': return 9.0;
    default:  return 0.0;
    }
}


// Eliminates the dot decimal separator in the double

double noDotDouble(char *toconvert) {
  double acc=charToDouble(toconvert[strlen(toconvert)-1]);
  double app=10.0;
  for(int cont=strlen(toconvert)-2;cont>=0;cont--) {
    acc+=(app*charToDouble(toconvert[cont]));
    app=app*10.0;
  }
  return acc;
};



/********************** END OF AUXILIARY FUNCTIONS ******************************/




/********************************** INTERFACE FUNCTIONS ***********************/


char* stringToChar(std::string toconvert) {
  const char *converted=toconvert.c_str();
  char* toreturn=new char[toconvert.length()+1];
  strcpy(toreturn,converted);
  return toreturn;
};


long stringToLong(std::string toconvert) {
  return atol(stringToChar(toconvert));
};

char* int_longToChar(long toconvert) {
  long app=toconvert;
  int count=0;
  while(app!=0) {app=app/10L;count++;}
  if (toconvert==0) count=1;
  if(toconvert<0) count++;
#ifdef TWO_DEBUG_MODE
  std::cout << "Il numero di cifre dell'intero, compreso il segno e' " << count << "\n";
#endif
  char* toreturn=new char[count+1];
  itoa(toconvert,toreturn);
  return toreturn;
};


double truncate(double totrunc) {
  double app=floor(totrunc);
  if (totrunc>=0.0) {
    if ( (totrunc-app)<0.0 ) app=app-1.0;
  }
  else {
    if ( (totrunc-app)>0.0 ) app=app+1.0;
  }
  return app;
};


char* floatToChar(double toconvert) {
  if (toconvert==0.0) {
    char *toreturn= new char[4];
    toreturn[0]='0';
    toreturn[1]='.';
    toreturn[2]='0';
    toreturn[3]='\0';
    return toreturn;
  }
  else {
    int dec,sign,digits;
    double copy=toconvert;
    double copy2=toconvert;
    if (copy2<0) copy2=-copy2;
    int leftdigits=1;
    while(copy2>=10.0) {copy2=copy2/10.0;leftdigits++;}
    char *app= fcvt(toconvert,16-leftdigits,&dec,&sign);
    digits=0;
    if(copy<0) copy=-copy;
    if(toconvert==0.0) {
      digits=1;
    }
    else { for(;copy<0.1;digits++) {copy=copy*10.0;} }
    int allocation=strlen(app)+2+digits;
    if (!(sign==0)) allocation++;
    if (dec<=0) allocation++;
    char *toreturn=new char[allocation];
    int written=0;
    if(!(sign==0)) {toreturn[0]='-';written++;}
    if(dec<=0) {toreturn[written++]='0';toreturn[written++]='.';}
    for(;digits>0;digits--) {toreturn[written++]='0';}
    int cont;
    for(cont=0;cont<dec;cont++) {
      toreturn[written++]=app[cont];
    }
    if(dec>0) toreturn[written++]='.';
    for(;cont<strlen(app);cont++) {
      toreturn[written++]=app[cont];
    }
    toreturn[allocation-1]='\0';
    return toreturn;
  }
};


char* fchr(double in) {
  double app=truncate(in);
  char* toparse=floatToChar(app);
  char* toreturn;
  if(toparse[0]=='0') {
    toreturn=new char[2];
    toreturn[0]='0';
    toreturn[1]='\0';
  }
  else if( (toparse[0]=='-') && (toparse[1]=='0') ) {
    toreturn=new char[2];
    toreturn[0]='0';
    toreturn[1]='\0';
  }
  else {
    int count=0;
    while((count<strlen(toparse)) && (!(toparse[count]=='.'))) {count++;}
    toreturn=new char[count+1];
    for(int cont1=0;cont1<count;cont1++) {
      toreturn[cont1]=toparse[cont1];
    }
    toreturn[count]='\0';
  }
  return toreturn;
};


char* mantissa(double in) {
  if (in==0.0) {
    char* toreturn=new char[2];
    toreturn[0]='0';
    toreturn[1]='\0';
    return toreturn;
  }
  else {
    char *toparse=floatToChar(in);
    int count=0;
    while((count<strlen(toparse)) && (!(toparse[count]=='.'))) {count++;}
    int allocation=strlen(toparse)-count;
    if(allocation==1) {
      char* toreturn=new char[2];
      toreturn[0]='0';
      toreturn[1]='\0';
      return toreturn;
    }
    unsigned int allzeros=1;
    for(int cont2=count+1;cont2<strlen(toparse);cont2++) {
      if(!(toparse[cont2]=='0')) allzeros=0;
    }
    if (allzeros) {
      char* toreturn=new char[2];
      toreturn[0]='0';
      toreturn[1]='\0';
      return toreturn;
    }
    int rv=strlen(toparse)-1;
    while(toparse[rv]=='0') { rv--; allocation--;}
    char* toreturn=new char[allocation];
    for(int cont=0;cont<allocation-1;cont++) {
      toreturn[cont]=toparse[cont+count+1];
    }
    toreturn[allocation-1]='\0';
    return toreturn;
  }
};


double stringToDouble(std::string toconvert) {
  unsigned int  dotfound=0;
  std::string h1,h2;
  for(int cont=0;cont<toconvert.length();cont++) {
    if(toconvert[cont]=='.') dotfound=1;
    else if(dotfound) h2+=toconvert[cont];
    else h1+=toconvert[cont];
  }
  char *left,*right;
  left=stringToChar(h1);
  right=stringToChar(h2);
  double one=noDotDouble(left);
  double two=noDotDouble(right);
  double app=1.0;
  for(int cont2=0;cont2<h2.length();cont2++) {
    app=app*10.0;
  }
  one=one*app;
  double toreturn=one+two;
  toreturn=toreturn/app;
  return toreturn;
};


/************************* END OF INTERFACE FUNCTIONS ***************************/
